Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 154432 - kernel dm-multipath uses default workqueue but sleeps causing other users problems
Summary: kernel dm-multipath uses default workqueue but sleeps causing other users pro...
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel
Version: 4.2
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
: ---
Assignee: Alasdair Kergon
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2005-04-11 17:23 UTC by Alasdair Kergon
Modified: 2007-11-30 22:07 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2005-11-15 18:11:19 UTC
Target Upstream Version:


Attachments (Terms of Use)
Separate workqueue for dm-mpath.c in kernel 2.6.5 (deleted)
2005-04-11 17:23 UTC, Alasdair Kergon
no flags Details | Diff
Updated separate workqueue patch (against 2.6.5-SLES, but based on the latest DM patchset) (deleted)
2005-04-20 09:53 UTC, Lars Marowsky-Bree
no flags Details | Diff

Description Alasdair Kergon 2005-04-11 17:23:51 UTC
Get a lot of IO to fail on the same dm multipath device and continue to
send new IO, so that the underlying device queue hits the nr_request and
batching limits and ends up blocking.
                                                                               
                                                     
If the generic_make_request call that ends up blocking comes from
dm-mpath.c's dispatch_failed_ios() then it will end up blocking all the
users of the default workqueue on that processor.
                                                                               
                                                     
A simple fix would be to just have dm-multipath use its own workqueue,
which is what the other device-mapper targets do to avoid the problem.

[From Mike Christie (IBM) via Suse]

Comment 1 Alasdair Kergon 2005-04-11 17:23:51 UTC
Created attachment 112957 [details]
Separate workqueue for dm-mpath.c in kernel 2.6.5

Comment 2 Lars Marowsky-Bree 2005-04-20 09:53:33 UTC
Created attachment 113400 [details]
Updated separate workqueue patch (against 2.6.5-SLES, but based on the latest DM patchset)

Comment 3 Alasdair Kergon 2005-04-21 16:59:30 UTC
Adding to 2.6.12-rc2-udm1

Comment 4 Alasdair Kergon 2005-11-15 18:11:19 UTC
upstream and in RHEL


Note You need to log in before you can comment on or make changes to this bug.